(*--------------------------------------------------------------------------*)
(*                             DATETIME.INC                                 *)
(*         include file to access            by Michael A. Covington        *)
(*--------------------------------------------------------------------------*)
type
    datetimetype = string[8];
    regtype      = record
                     ax,bx,cx,dx,bp,si,di,ds,es,flags:integer
                   end;

function date: datetimetype; (*returns the current date in form '08/31/84'.*)
var
   reg      : regtype;
   y,m,d,w  : datetimetype;
   i        : integer;

begin
     reg.ax:=$2A00;
     intr($21,reg);
     str(reg.cx:4,y);
     delete(y,1,2);
     str(hi(reg.dx):2,m);
     str(lo(reg.dx):2,d);
     w:=m+'/'+d+'/'+y;
     for i:= 1 to length(w) do if w[i]=' ' then w[i]:='0';
     date:=w
end;

function time:datetimetype; (*returns current time in form '08:13:59'.*)
var
   reg     : regtype;
   h,m,s,w : datetimetype;
   i       : integer;

begin
     reg.ax:=$2C00;
     intr($21,reg);
     str(hi(reg.cx):2,h);
     str(lo(reg.cx):2,m);
     str(hi(reg.dx):2,s);
     w:=h+':'+m+':'+s;
     for i:=1 to length(w) do if w[i]=' ' then w[i] := '0';
     time:=w
end;